# Code generated by `py-sdk-gen`. DO NOT EDIT.
import os
import httpx
from functools import cached_property

from ._service import Service, AsyncService
from .checkouts.service import CheckoutsService, AsyncCheckoutsService
from .customers.service import CustomersService, AsyncCustomersService
from .members.service import MembersService, AsyncMembersService
from .memberships.service import MembershipsService, AsyncMembershipsService
from .merchant.service import MerchantService, AsyncMerchantService
from .payouts.service import PayoutsService, AsyncPayoutsService
from .readers.service import ReadersService, AsyncReadersService
from .receipts.service import ReceiptsService, AsyncReceiptsService
from .roles.service import RolesService, AsyncRolesService
from .subaccounts.service import SubaccountsService, AsyncSubaccountsService
from .transactions.service import TransactionsService, AsyncTransactionsService

BASE_URL = "https://api.sumup.com"


class Sumup(Service):
    def __init__(self, api_key: str = None, base_url: str = BASE_URL):
        self.api_key = api_key or os.getenv("SUMUP_API_KEY")
        super().__init__(
            httpx.Client(
                base_url=base_url,
                headers={
                    "User-Agent": f"sumup-py/{self.version}",
                    "Authorization": f"Bearer {self.api_key}",
                },
            )
        )

    @cached_property
    def checkouts(self) -> CheckoutsService:
        from .checkouts.service import CheckoutsService

        return CheckoutsService(self._client)

    @cached_property
    def customers(self) -> CustomersService:
        from .customers.service import CustomersService

        return CustomersService(self._client)

    @cached_property
    def members(self) -> MembersService:
        from .members.service import MembersService

        return MembersService(self._client)

    @cached_property
    def memberships(self) -> MembershipsService:
        from .memberships.service import MembershipsService

        return MembershipsService(self._client)

    @cached_property
    def merchant(self) -> MerchantService:
        from .merchant.service import MerchantService

        return MerchantService(self._client)

    @cached_property
    def payouts(self) -> PayoutsService:
        from .payouts.service import PayoutsService

        return PayoutsService(self._client)

    @cached_property
    def readers(self) -> ReadersService:
        from .readers.service import ReadersService

        return ReadersService(self._client)

    @cached_property
    def receipts(self) -> ReceiptsService:
        from .receipts.service import ReceiptsService

        return ReceiptsService(self._client)

    @cached_property
    def roles(self) -> RolesService:
        from .roles.service import RolesService

        return RolesService(self._client)

    @cached_property
    def subaccounts(self) -> SubaccountsService:
        from .subaccounts.service import SubaccountsService

        return SubaccountsService(self._client)

    @cached_property
    def transactions(self) -> TransactionsService:
        from .transactions.service import TransactionsService

        return TransactionsService(self._client)


class AsyncSumup(AsyncService):
    def __init__(self, api_key: str = None, base_url: str = BASE_URL):
        self.api_key = api_key or os.getenv("SUMUP_API_KEY")
        super().__init__(
            httpx.AsyncClient(
                base_url=base_url,
                headers={
                    "User-Agent": f"sumup-py/{self.version}",
                    "Authorization": f"Bearer {self.api_key}",
                },
            )
        )

    @cached_property
    def checkouts(self) -> AsyncCheckoutsService:
        from .checkouts.service import AsyncCheckoutsService

        return AsyncCheckoutsService(self._client)

    @cached_property
    def customers(self) -> AsyncCustomersService:
        from .customers.service import AsyncCustomersService

        return AsyncCustomersService(self._client)

    @cached_property
    def members(self) -> AsyncMembersService:
        from .members.service import AsyncMembersService

        return AsyncMembersService(self._client)

    @cached_property
    def memberships(self) -> AsyncMembershipsService:
        from .memberships.service import AsyncMembershipsService

        return AsyncMembershipsService(self._client)

    @cached_property
    def merchant(self) -> AsyncMerchantService:
        from .merchant.service import AsyncMerchantService

        return AsyncMerchantService(self._client)

    @cached_property
    def payouts(self) -> AsyncPayoutsService:
        from .payouts.service import AsyncPayoutsService

        return AsyncPayoutsService(self._client)

    @cached_property
    def readers(self) -> AsyncReadersService:
        from .readers.service import AsyncReadersService

        return AsyncReadersService(self._client)

    @cached_property
    def receipts(self) -> AsyncReceiptsService:
        from .receipts.service import AsyncReceiptsService

        return AsyncReceiptsService(self._client)

    @cached_property
    def roles(self) -> AsyncRolesService:
        from .roles.service import AsyncRolesService

        return AsyncRolesService(self._client)

    @cached_property
    def subaccounts(self) -> AsyncSubaccountsService:
        from .subaccounts.service import AsyncSubaccountsService

        return AsyncSubaccountsService(self._client)

    @cached_property
    def transactions(self) -> AsyncTransactionsService:
        from .transactions.service import AsyncTransactionsService

        return AsyncTransactionsService(self._client)
