# Code generated by `py-sdk-gen`. DO NOT EDIT.
from .._service import Service, AsyncService
from .types import FinancialPayouts
from datetime import date
import typing
import pydantic


class ListPayoutsParams(pydantic.BaseModel):
    """
    ListPayoutsParams: query parameters for ListPayouts
    """

    end_date: date
    """
	End date (in [ISO8601](https://en.wikipedia.org/wiki/ISO_8601) format).
	"""

    start_date: date
    """
	Start date (in [ISO8601](https://en.wikipedia.org/wiki/ISO_8601) format).
	"""

    format: typing.Optional[str] = None

    limit: typing.Optional[int] = None

    order: typing.Optional[str] = None


class ListPayoutsV1Params(pydantic.BaseModel):
    """
    ListPayoutsV1Params: query parameters for ListPayoutsV1
    """

    end_date: date
    """
	End date (in [ISO8601](https://en.wikipedia.org/wiki/ISO_8601) format).
	"""

    start_date: date
    """
	Start date (in [ISO8601](https://en.wikipedia.org/wiki/ISO_8601) format).
	"""

    format: typing.Optional[str] = None

    limit: typing.Optional[int] = None

    order: typing.Optional[str] = None


class PayoutsService(Service):
    def __init__(self, client):
        super().__init__(client)

    def list_deprecated(self, params: ListPayoutsParams | None = None) -> FinancialPayouts:
        """
        list_deprecated: List payouts
        Lists ordered payouts for the merchant profile.
        Deprecated: this operation is deprecated
        """
        resp = self._client.get(
            "/v0.1/me/financials/payouts",
            params=params.dict(),
        )
        return FinancialPayouts(**resp.json())

    def list(
        self, merchant_code: str, params: ListPayoutsV1Params | None = None
    ) -> FinancialPayouts:
        """
        list: List payouts
        Lists ordered payouts for the merchant profile.
        """
        resp = self._client.get(
            f"/v1.0/merchants/{merchant_code}/payouts",
            params=params.dict(),
        )
        return FinancialPayouts(**resp.json())


class AsyncPayoutsService(AsyncService):
    def __init__(self, client):
        super().__init__(client)

    async def list_deprecated(self, params: ListPayoutsParams | None = None) -> FinancialPayouts:
        """
        list_deprecated: List payouts
        Lists ordered payouts for the merchant profile.
        Deprecated: this operation is deprecated
        """
        resp = await self._client.get(
            "/v0.1/me/financials/payouts",
            params=params.dict(),
        )
        return FinancialPayouts(**resp.json())

    async def list(
        self, merchant_code: str, params: ListPayoutsV1Params | None = None
    ) -> FinancialPayouts:
        """
        list: List payouts
        Lists ordered payouts for the merchant profile.
        """
        resp = await self._client.get(
            f"/v1.0/merchants/{merchant_code}/payouts",
            params=params.dict(),
        )
        return FinancialPayouts(**resp.json())
