# Code generated by `py-sdk-gen`. DO NOT EDIT.
from .._service import Service, AsyncService
from .types import Metadata, Role
import typing
import pydantic


class CreateMerchantRoleBody(pydantic.BaseModel):
    """
    CreateMerchantRoleBody is a schema definition.
    """

    name: str
    """
	User-defined name of the role.
	"""

    permissions: typing.List[str]
    """
	User's permissions.
	Max items: 100
	"""

    description: typing.Optional[str] = None
    """
	User-defined description of the role.
	"""

    metadata: typing.Optional[Metadata] = None
    """
	Set of user-defined key-value pairs attached to the object. Partial updates are not supported. When updating, alwayssubmit whole metadata.
	"""


class UpdateMerchantRoleBody(pydantic.BaseModel):
    """
    UpdateMerchantRoleBody is a schema definition.
    """

    description: typing.Optional[str] = None
    """
	User-defined description of the role.
	"""

    name: typing.Optional[str] = None
    """
	User-defined name of the role.
	"""

    permissions: typing.Optional[typing.List[str]] = None
    """
	User's permissions.
	Max items: 100
	"""


class ListMerchantRoles200Response(pydantic.BaseModel):
    """
    ListMerchantRoles200Response is a schema definition.
    """

    items: typing.List[Role]


class RolesService(Service):
    def __init__(self, client):
        super().__init__(client)

    def list(self, merchant_code: str) -> ListMerchantRoles200Response:
        """
        list: List roles
        List merchant's custom roles.
        """
        resp = self._client.get(
            f"/v0.1/merchants/{merchant_code}/roles",
        )
        return ListMerchantRoles200Response(**resp.json())

    def create(self, merchant_code: str, body: CreateMerchantRoleBody) -> Role:
        """
        create: Create a role
        Create a custom role for the merchant. Roles are defined by the set of permissions that they grant to the members thatthey are assigned to.
        """
        resp = self._client.post(
            f"/v0.1/merchants/{merchant_code}/roles",
            json=body,
        )
        return Role(**resp.json())

    def delete(self, merchant_code: str, role_id: str):
        """
        delete: Delete a role
        Delete a custom role.
        """
        self._client.delete(
            f"/v0.1/merchants/{merchant_code}/roles/{role_id}",
        )

    def get(self, merchant_code: str, role_id: str) -> Role:
        """
        get: Retrieve a role
        Retrieve a custom role by ID.
        """
        resp = self._client.get(
            f"/v0.1/merchants/{merchant_code}/roles/{role_id}",
        )
        return Role(**resp.json())

    def update(self, merchant_code: str, role_id: str, body: UpdateMerchantRoleBody) -> Role:
        """
        update: Update a role
        Update a custom role.
        """
        resp = self._client.patch(
            f"/v0.1/merchants/{merchant_code}/roles/{role_id}",
            json=body,
        )
        return Role(**resp.json())


class AsyncRolesService(AsyncService):
    def __init__(self, client):
        super().__init__(client)

    async def list(self, merchant_code: str) -> ListMerchantRoles200Response:
        """
        list: List roles
        List merchant's custom roles.
        """
        resp = await self._client.get(
            f"/v0.1/merchants/{merchant_code}/roles",
        )
        return ListMerchantRoles200Response(**resp.json())

    async def create(self, merchant_code: str, body: CreateMerchantRoleBody) -> Role:
        """
        create: Create a role
        Create a custom role for the merchant. Roles are defined by the set of permissions that they grant to the members thatthey are assigned to.
        """
        resp = await self._client.post(
            f"/v0.1/merchants/{merchant_code}/roles",
            json=body,
        )
        return Role(**resp.json())

    async def delete(self, merchant_code: str, role_id: str):
        """
        delete: Delete a role
        Delete a custom role.
        """
        await self._client.delete(
            f"/v0.1/merchants/{merchant_code}/roles/{role_id}",
        )

    async def get(self, merchant_code: str, role_id: str) -> Role:
        """
        get: Retrieve a role
        Retrieve a custom role by ID.
        """
        resp = await self._client.get(
            f"/v0.1/merchants/{merchant_code}/roles/{role_id}",
        )
        return Role(**resp.json())

    async def update(self, merchant_code: str, role_id: str, body: UpdateMerchantRoleBody) -> Role:
        """
        update: Update a role
        Update a custom role.
        """
        resp = await self._client.patch(
            f"/v0.1/merchants/{merchant_code}/roles/{role_id}",
            json=body,
        )
        return Role(**resp.json())
